local ret = ... or {}

local OldRedir = ret.Redir;
ret.Redir = function(sButton, sElement)
	-- To redirect files for Up to Down:
	-- if sButton == "Up" then sButton = "Down"; end

	if not (sElement == "Hold Body Active") and
	   not (sElement == "Hold Body Inactive") and
	   not (sElement == "Hold Bottomcap Active") and
	   not (sElement == "Hold Bottomcap Inactive") 
	then
	--[[	sButton, sElement = OldRedir(sButton, sElement);
		sButton = ret.RedirTable[sButton];]]

		if sButton == "Up" or
		   sButton == "Left" or
		   sButton == "Right"
		then
		   sButton = "Down"; 
		end 
	end
	


	return sButton, sElement;
end

ret.Rotate =
{
	Up = 180,
	Down = 0,
	Left = 90,
	Right = -90,
	UpLeft = 0,
	UpRight = 0,
};

ret.RedirTable =
{
	Up = "Down",
	Down = "Down",
	Left = "Down",
	Right = "Down",
	UpLeft = "Down",
	UpRight = "Down",
};

ret.PartsToRotate =
{
	["Receptor"] = true,
	["Go Receptor"] = true,
	["Ready Receptor"] = true,
	["Tap Note"] = true,
	["Tap Mine"] = true,
	["Tap Lift"] = true,
	["Hold Head Active"] = true,
	["Hold Head Inactive"] = true,
	["Roll Head Active"] = true,
	["Roll Head Inactive"] = true,
	["Explosion"] = true;
};

ret.Blank =
{
	["Tap Lift"] = true,
	["Hold Topcap Active"] = true,
	["Hold Topcap Inactive"] = true,
	["Hold Tail Active"] = true,
	["Hold Tail Inactive"] = true,
	["Roll Topcap Active"] = true,
	["Roll Topcap Inactive"] = true,
	["Roll Head Active"] = true,
	["Roll Head Inactive"] = true, 
	["Roll Body Active"] = true,
	["Roll Body Inactive"] = true,
	["Roll Bottomcap Active"] = true,
	["Roll Bottomcap Inactive"] = true,
	["Roll Tail Active"] = true,
	["Roll Tail Inactive"] = true,
	["Roll Explosion"] = true,
};

local function func()
	local sButton = Var "Button";
	local sElement = Var "Element";

	if ret.Blank[sElement] then
		-- Return a blank element.  If SpriteOnly is set,
		-- we need to return a sprite; otherwise just return
		-- a dummy actor.
		local t;
		if Var "SpriteOnly" then
			t = LoadActor( "_blank" );
		else
			t = Def.Actor {};
		end
		return t .. {
			cmd(hidden,true);
		};
	end

	local sButtonToLoad, sElementToLoad = ret.Redir(sButton, sElement);
	assert( sButtonToLoad );
	assert( sElementToLoad );

	local sPath = NOTESKIN:GetPath( sButtonToLoad, sElementToLoad );

	local t = LoadActor( sPath );

	if ret.PartsToRotate[sElement] then
		t.BaseRotationZ = ret.Rotate[sButton];
	end

	return t;
end

-- This is the only required function.
ret.Load = func;

-- Use this to override the game types' default Load() functions.
ret.CommonLoad = func;

return ret;
